;===========================================================================================
; ListBox2.asm  Fasm Flat assembler
; Fichiers en listes
; Programm par AsmGges France
;===========================================================================================

format PE GUI 4.0
entry start

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  include 'win32a.inc'
  include 'macro\if.inc'

  DDL_DIRECTORY = 010h
  DDL_ARCHIVE   = 020h
  DDL_DRIVES    = 04000h

;===========================================================================================
; Dbut du code programme
;-------------------------------------------------------------------------------------------
section '.code' code readable executable

 start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne spcifique
    ; ---------------------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur systme
    ; -------------------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Valider la structure WNDCLASS
    ; -----------------------------
    invoke RegisterClass,wc

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_LEFT,ClassName,Titre,WS_CAPTION+WS_SYSMENU+\
                          WS_MINIMIZEBOX,[WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWin],eax

    ; Affiche et rafraichit la fentre
    ; --------------------------------
    invoke ShowWindow,[hWin],SW_SHOWNORMAL
    invoke UpdateWindow,[hWin]

 ; Boucle des messages
 ; -------------------
 MessageLoop:
    invoke GetMessage,msg,NULL,0,0
    or eax,eax
    jz ExitProgram
    invoke TranslateMessage,msg
    invoke DispatchMessage,msg
    jmp MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
proc WindowProc uses ebx esi edi, @hWnd, @uMsg, @wParam, @lParam

    .if [@uMsg] = WM_CLOSE
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],MsgInfo,ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke PostQuitMessage,0

    .elseif [@uMsg] = WM_CREATE
        ; Cration d'une fonte de texte
        ; -----------------------------
        invoke CreateFont,8,0,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,\
                          CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH+FF_SWISS,NFont
        mov [hFont],eax

        ; Groupbox AsmGges
        ; ----------------
        stdcall Ctl,Button,ClassName,[@hWnd],8,10,408,20,-1,BS_GROUPBOX,0
        ; Affecter la fonte au control
        ; ----------------------------
        invoke SendMessage,eax,WM_SETFONT,[hFont],NULL

        ; Cration d'une fentre gauche list1
        ; -----------------------------------
        stdcall Ctl,ListBox,NoTxt,[@hWnd],20,44,180,160,-1,WS_VSCROLL+WS_BORDER+\
                        LBS_HASSTRINGS+LBS_NOINTEGRALHEIGHT+LBS_DISABLENOSCROLL,\
                                                               WS_EX_CLIENTEDGE
        mov [hList1],eax
        ; Affecter la fonte au control
        ; ----------------------------
        invoke SendMessage,[hList1],WM_SETFONT,[hFont],NULL

        invoke SendMessage,[hList1],LB_DIR,DDL_ARCHIVE+DDL_DRIVES+DDL_DIRECTORY,Patn

        ; Redirection adresse WindowProc
        ; ------------------------------
        invoke SetWindowLong,[hList1],GWL_WNDPROC,ListBoxProc
        mov [lpLstBox1],eax

        ; Cration d'une fentre droite list2
        ; -----------------------------------
        stdcall Ctl,ListBox,NoTxt,[@hWnd],220,44,180,160,-1,WS_VSCROLL+WS_BORDER+\
                         LBS_HASSTRINGS+LBS_NOINTEGRALHEIGHT+LBS_DISABLENOSCROLL,\
                                                                WS_EX_CLIENTEDGE
        mov [hList2],eax
        ; Affecter la fonte au control
        ; ----------------------------
        invoke SendMessage,[hList2],WM_SETFONT,[hFont],NULL

        ; Redirection adresse WindowProc
        ; ------------------------------
        invoke SetWindowLong,[hList2],GWL_WNDPROC,ListBoxProc
        mov [lpLstBox1],eax

        invoke SendMessage,[hList2],LB_ADDSTRING,0,lItem1
        invoke SendMessage,[hList2],LB_ADDSTRING,0,lItem2
        invoke SendMessage,[hList2],LB_ADDSTRING,0,lItem3
        invoke SendMessage,[hList2],LB_ADDSTRING,0,lItem4

    .else
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .endif

    mov eax,0
    ret
endp

;==========================================================================================

proc ListBoxProc @hCtl, @uMsg, @wParam, @lParam

    .if [@uMsg] = WM_LBUTTONDBLCLK
        jmp .L1

    .elseif [@uMsg] = WM_CHAR
        .if [@wParam] = 13
            jmp .L1
        .endif

    .endif
    jmp .L2

 .L1:
    invoke SendMessage,[@hCtl],LB_GETCURSEL,0,0
    mov [IndexItem],eax

    invoke SendMessage,[@hCtl],LB_GETTEXT,[IndexItem],Buffer

    mov eax,[hList1]
    .if [@hCtl] = eax
        invoke MessageBox,[hWin],Buffer,CurSel1,MB_OK
    .else
        invoke MessageBox,[hWin],Buffer,CurSel2,MB_OK
    .endif

 .L2:
    invoke CallWindowProc,[lpLstBox1],[@hCtl],[@uMsg],[@wParam],[@lParam]

    ret
endp

;===========================================================================================
; Cration d'une fentre-enfant control class
;-------------------------------------------------------------------------------------------
; @Class   = adresse du nom de control class
; @AdrText = adresse du control text
; @hParent = handle de la fentre parent
; @X       = x-coordonne fentre-enfant
; @Y       = y-coordonne fentre-enfant
; @wX      = largeur en pixels fentre-enfant
; @hY      = hauteur en pixels fentre-enfant
; @Id      = identificateur du control forme ID_XXX ou -1 si pas de ID
; @Style   = complment window style de WS_CHILD+WS_VISIBLE
; @ExStyle = window style tendu
;-------------------------------------------------------------------------------------------
; sortie eax = handle de la fentre-enfant
;-------------------------------------------------------------------------------------------
proc Ctl @Class, @AdrText, @hParent, @X, @Y, @wX, @hY, @Id, @Style, @ExStyle

    mov eax,WS_CHILD+WS_VISIBLE
    add eax,[@Style]
    invoke CreateWindowEx,[@ExStyle],[@Class],[@AdrText],eax,[@X],[@Y],[@wX],[@hY],\
                          [@hParent],[@Id],[wc.hInstance],0
    ret
endp

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
section '.data' data readable writeable

  Titre       db ' ListBox',0
  ClassName   db ' AsmGges Win32',0
  MsgInfo     db ' AsmGges @2006 France',0

  NFont       db 'Ms Sans Serif',0
  ListBox     db 'LISTBOX',0
  Button      db 'BUTTON',0
  NoTxt       db '',0
  Patn        db "*.*",0
  align 4

  lItem1      db 'Roses are red,',0
  lItem2      db 'Violets are blue.',0
  lItem3      db 'If sugar is sweet,',0
  lItem4      db 'What happened to you ?',0
  CurSel1     db 'Slection List1',0
  CurSel2     db 'Slection List2',0
  align 4

  WinX        dd 0
  WinY        dd 100
  WinW        dd 430
  WinH        dd 260
  Buffer:     db 32 dup (0)

  hWin        dd ?
  hFont       dd ?

  hList1      dd ?
  hList2      dd ?
  lpLstBox1   dd ?
  IndexItem   dd ?

  wc          WNDCLASS  0,WindowProc,0,0,0,0,0,COLOR_BTNFACE+1,0,ClassName
  msg         MSG
  ps          PAINTSTRUCT

;===========================================================================================
; Inclusion des fichiers .dll contenant les fonctions Windows utilises
;-------------------------------------------------------------------------------------------
section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
            user32,'USER32.DLL',\
             gdi32,'GDI32.DLL'

  ; Apis Windows dans fichiers dlls
  ; -------------------------------
  include 'apia/kernel32.inc'
  include 'apia/user32.inc'
  include 'apia/gdi32.inc'

;===========================================================================================
; Inclusion des icnes / curseurs / bitmap
;-------------------------------------------------------------------------------------------
section '.rsrc' resource data readable

  directory RT_ICON,icons,\
            RT_GROUP_ICON,group_icons

  ID_FRANCE = 17

  resource icons,\
           1,LANG_NEUTRAL,france_data

  resource group_icons,\
           ID_FRANCE,LANG_NEUTRAL,france

  icon france,france_data,'res\france.ico'

;===========================================================================================

